
/*************************************************************************

SIUDS - Secure Interface for a Universal Data Server. 
Copyright (C) 2000  Flavia Linhalis, Dilvan Moreira

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Contact: flavialin@bol.com.br
         dilvan@computer.org
         Paper mail: SCE-ICMC-USP Caixa Postal 668
                     Av Dr Carlos Botelho, 1465
                     13560-970 Sao Carlos-SP
                     BRAZIL

***************************************************************************/

/** Tests the following methods of the DBImplementation class:
 * <UL>
 * <LI> <code>long</code> getTime(String groupName);
 * <LI> <code>boolean</code> isGroup(String groupName);
 * <LI> createRoot(String rootName);
 * <LI> <code>boolean</code> isRoot(String rootName);
 * <LI> <code>String[]</code> getRoots();
 * </UL>
 * It gets the superusers and commonusers time.
 * It tests if the communusers and testGoup are valid groups.
 * It creates Root 1, Root 2 and Root 3.
 * It tests if Root 1 and Root 4 are valid roots.
 * It prints all the roots' names
 */

package testagents;

import structures.DBImplementation;

public class TestAgent1 {
   public static void main(String[] args) throws Exception {

	    DBImplementation dbi = new DBImplementation();

    	long l = dbi.getTime("superusers");
    	System.out.println("O grupo de superusers tem o tempo:" + l);
    	long l2 = dbi.getTime("commonusers");
    	System.out.println("O grupo de commonusers tem o tempo:" + l2);

    	boolean a2 = dbi.isGroup("commonusers");
    	System.out.println(a2);
    	boolean b2 = dbi.isGroup("testGroup");
    	System.out.println(b2);

    	dbi.createRoot("Root 1");
    	dbi.createRoot("Root 2");
    	dbi.createRoot("Root 3");
    	boolean a = dbi.isRoot("Root 1");
    	System.out.println(a);
    	boolean b = dbi.isRoot("Root 4");
    	System.out.println(b);
    	String[] s = dbi.getRoots();
    	System.out.println("Roots existentes: ");
    	for (int i = 0; i < s.length; i++) {
	       System.out.println(s[i]);
	    }
   }
}


